// Code generated by gotdgen, DO NOT EDIT.

package tdapi

import (
	"context"
	"errors"
	"fmt"
	"sort"
	"strings"

	"go.uber.org/multierr"

	"github.com/gotd/td/bin"
	"github.com/gotd/td/tdjson"
	"github.com/gotd/td/tdp"
	"github.com/gotd/td/tgerr"
)

// No-op definition for keeping imports.
var (
	_ = bin.Buffer{}
	_ = context.Background()
	_ = fmt.Stringer(nil)
	_ = strings.Builder{}
	_ = errors.Is
	_ = multierr.AppendInto
	_ = sort.Ints
	_ = tdp.Format
	_ = tgerr.Error{}
	_ = tdjson.Encoder{}
)

// GroupCallStream represents TL type `groupCallStream#f03b0fc5`.
type GroupCallStream struct {
	// Identifier of an audio/video channel
	ChannelID int32
	// Scale of segment durations in the stream. The duration is 1000/(2**scale) milliseconds
	Scale int32
	// Point in time when the stream currently ends; Unix timestamp in milliseconds
	TimeOffset int64
}

// GroupCallStreamTypeID is TL type id of GroupCallStream.
const GroupCallStreamTypeID = 0xf03b0fc5

// Ensuring interfaces in compile-time for GroupCallStream.
var (
	_ bin.Encoder     = &GroupCallStream{}
	_ bin.Decoder     = &GroupCallStream{}
	_ bin.BareEncoder = &GroupCallStream{}
	_ bin.BareDecoder = &GroupCallStream{}
)

func (g *GroupCallStream) Zero() bool {
	if g == nil {
		return true
	}
	if !(g.ChannelID == 0) {
		return false
	}
	if !(g.Scale == 0) {
		return false
	}
	if !(g.TimeOffset == 0) {
		return false
	}

	return true
}

// String implements fmt.Stringer.
func (g *GroupCallStream) String() string {
	if g == nil {
		return "GroupCallStream(nil)"
	}
	type Alias GroupCallStream
	return fmt.Sprintf("GroupCallStream%+v", Alias(*g))
}

// TypeID returns type id in TL schema.
//
// See https://core.telegram.org/mtproto/TL-tl#remarks.
func (*GroupCallStream) TypeID() uint32 {
	return GroupCallStreamTypeID
}

// TypeName returns name of type in TL schema.
func (*GroupCallStream) TypeName() string {
	return "groupCallStream"
}

// TypeInfo returns info about TL type.
func (g *GroupCallStream) TypeInfo() tdp.Type {
	typ := tdp.Type{
		Name: "groupCallStream",
		ID:   GroupCallStreamTypeID,
	}
	if g == nil {
		typ.Null = true
		return typ
	}
	typ.Fields = []tdp.Field{
		{
			Name:       "ChannelID",
			SchemaName: "channel_id",
		},
		{
			Name:       "Scale",
			SchemaName: "scale",
		},
		{
			Name:       "TimeOffset",
			SchemaName: "time_offset",
		},
	}
	return typ
}

// Encode implements bin.Encoder.
func (g *GroupCallStream) Encode(b *bin.Buffer) error {
	if g == nil {
		return fmt.Errorf("can't encode groupCallStream#f03b0fc5 as nil")
	}
	b.PutID(GroupCallStreamTypeID)
	return g.EncodeBare(b)
}

// EncodeBare implements bin.BareEncoder.
func (g *GroupCallStream) EncodeBare(b *bin.Buffer) error {
	if g == nil {
		return fmt.Errorf("can't encode groupCallStream#f03b0fc5 as nil")
	}
	b.PutInt32(g.ChannelID)
	b.PutInt32(g.Scale)
	b.PutInt53(g.TimeOffset)
	return nil
}

// Decode implements bin.Decoder.
func (g *GroupCallStream) Decode(b *bin.Buffer) error {
	if g == nil {
		return fmt.Errorf("can't decode groupCallStream#f03b0fc5 to nil")
	}
	if err := b.ConsumeID(GroupCallStreamTypeID); err != nil {
		return fmt.Errorf("unable to decode groupCallStream#f03b0fc5: %w", err)
	}
	return g.DecodeBare(b)
}

// DecodeBare implements bin.BareDecoder.
func (g *GroupCallStream) DecodeBare(b *bin.Buffer) error {
	if g == nil {
		return fmt.Errorf("can't decode groupCallStream#f03b0fc5 to nil")
	}
	{
		value, err := b.Int32()
		if err != nil {
			return fmt.Errorf("unable to decode groupCallStream#f03b0fc5: field channel_id: %w", err)
		}
		g.ChannelID = value
	}
	{
		value, err := b.Int32()
		if err != nil {
			return fmt.Errorf("unable to decode groupCallStream#f03b0fc5: field scale: %w", err)
		}
		g.Scale = value
	}
	{
		value, err := b.Int53()
		if err != nil {
			return fmt.Errorf("unable to decode groupCallStream#f03b0fc5: field time_offset: %w", err)
		}
		g.TimeOffset = value
	}
	return nil
}

// EncodeTDLibJSON implements tdjson.TDLibEncoder.
func (g *GroupCallStream) EncodeTDLibJSON(b tdjson.Encoder) error {
	if g == nil {
		return fmt.Errorf("can't encode groupCallStream#f03b0fc5 as nil")
	}
	b.ObjStart()
	b.PutID("groupCallStream")
	b.Comma()
	b.FieldStart("channel_id")
	b.PutInt32(g.ChannelID)
	b.Comma()
	b.FieldStart("scale")
	b.PutInt32(g.Scale)
	b.Comma()
	b.FieldStart("time_offset")
	b.PutInt53(g.TimeOffset)
	b.Comma()
	b.StripComma()
	b.ObjEnd()
	return nil
}

// DecodeTDLibJSON implements tdjson.TDLibDecoder.
func (g *GroupCallStream) DecodeTDLibJSON(b tdjson.Decoder) error {
	if g == nil {
		return fmt.Errorf("can't decode groupCallStream#f03b0fc5 to nil")
	}

	return b.Obj(func(b tdjson.Decoder, key []byte) error {
		switch string(key) {
		case tdjson.TypeField:
			if err := b.ConsumeID("groupCallStream"); err != nil {
				return fmt.Errorf("unable to decode groupCallStream#f03b0fc5: %w", err)
			}
		case "channel_id":
			value, err := b.Int32()
			if err != nil {
				return fmt.Errorf("unable to decode groupCallStream#f03b0fc5: field channel_id: %w", err)
			}
			g.ChannelID = value
		case "scale":
			value, err := b.Int32()
			if err != nil {
				return fmt.Errorf("unable to decode groupCallStream#f03b0fc5: field scale: %w", err)
			}
			g.Scale = value
		case "time_offset":
			value, err := b.Int53()
			if err != nil {
				return fmt.Errorf("unable to decode groupCallStream#f03b0fc5: field time_offset: %w", err)
			}
			g.TimeOffset = value
		default:
			return b.Skip()
		}
		return nil
	})
}

// GetChannelID returns value of ChannelID field.
func (g *GroupCallStream) GetChannelID() (value int32) {
	if g == nil {
		return
	}
	return g.ChannelID
}

// GetScale returns value of Scale field.
func (g *GroupCallStream) GetScale() (value int32) {
	if g == nil {
		return
	}
	return g.Scale
}

// GetTimeOffset returns value of TimeOffset field.
func (g *GroupCallStream) GetTimeOffset() (value int64) {
	if g == nil {
		return
	}
	return g.TimeOffset
}
